"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var transport_1 = require("@connectv/sdh/transport");
var core_1 = require("@connectv/core");
var style_1 = require("./style");
var mode_1 = require("./mode");
var system_1 = require("./system");
function DarkModeSwitch(_, renderer) {
    var classes = this.theme.classes(style_1.DarkModeSwitchStyle);
    var sysMode = system_1.systemMode();
    var runningMode = core_1.state();
    var storageLoaded = false;
    sysMode.to(runningMode);
    this.track(runningMode.to(core_1.sink(function (mode) {
        if (mode === mode_1.Mode.Light)
            document.body.classList.remove('dark');
        else
            document.body.classList.add('dark');
        if (storageLoaded) {
            if (mode !== sysMode.value)
                localStorage.setItem('dark-mode', (mode === mode_1.Mode.Light) ? 'false' : 'true');
            else
                localStorage.removeItem('dark-mode');
        }
    })));
    this.track({
        bind: function () {
            if (localStorage.getItem('dark-mode'))
                runningMode.value = localStorage.getItem('dark-mode') === 'true' ? mode_1.Mode.Dark : mode_1.Mode.Light;
            document.body.classList.add('dark-mode-animate');
            storageLoaded = true;
        }
    });
    return renderer.create("div", { class: classes.dmSwitch, onclick: function () { return runningMode.value = mode_1.switchMode(runningMode.value); } },
        renderer.create("div", { class: "arc" }),
        renderer.create("div", { class: "darc" }),
        renderer.create("div", { class: "ray one" }),
        renderer.create("div", { class: "ray two" }),
        renderer.create("div", { class: "ray three" }),
        renderer.create("div", { class: "ray four" }),
        renderer.create("div", { class: "ray five" }),
        renderer.create("div", { class: "ray six" }),
        renderer.create("div", { class: "ray seven" }),
        renderer.create("div", { class: "ray eight" }));
}
exports.DarkModeSwitch = DarkModeSwitch;
exports.DarkModeSwitch$ = transport_1.transport(DarkModeSwitch);
__export(require("./darklight"));
//# sourceMappingURL=index.js.map